package controller;

import model.*;
import view.homeViewForm;
import view.itemViewForm;
import view.payViewForm;
import view.refundViewForm;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class homeController {

    private homeViewForm view;
    private Register model;

    public homeController(homeViewForm view, Register model){
        this.view = view;
        this.model = model;

        updateOrderDisplay();

        view.form.getRefundButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                newRefundView();
            }
        });

        view.form.getExitButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                System.exit(1);
            }
        });

        view.form.getCancelButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                model.getActiveOrder().clear();
                updateOrderDisplay();
            }
        });

        view.form.getEntréeButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                view.form.getDoubleBurgerButton().setVisible(true);
                view.form.getBurgerButton().setVisible(true);
                view.form.getHotDogButton().setVisible(true);
                view.form.getGrilledCheeseButton().setVisible(true);

                view.form.getLargeFryButton().setVisible(false);
                view.form.getMediumFryButton().setVisible(false);
                view.form.getSmallFryButton().setVisible(false);

                view.form.getMediumSodaButton().setVisible(false);
                view.form.getSmallSodaButton().setVisible(false);
                view.form.getLargeSodaButton().setVisible(false);

            }
        });

        view.form.getSidesButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                view.form.getDoubleBurgerButton().setVisible(false);
                view.form.getBurgerButton().setVisible(false);
                view.form.getHotDogButton().setVisible(false);
                view.form.getGrilledCheeseButton().setVisible(false);

                view.form.getLargeFryButton().setVisible(true);
                view.form.getMediumFryButton().setVisible(true);
                view.form.getSmallFryButton().setVisible(true);

                view.form.getMediumSodaButton().setVisible(false);
                view.form.getSmallSodaButton().setVisible(false);
                view.form.getLargeSodaButton().setVisible(false);
            }
        });

        view.form.getDrinksButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                view.form.getDoubleBurgerButton().setVisible(false);
                view.form.getBurgerButton().setVisible(false);
                view.form.getHotDogButton().setVisible(false);
                view.form.getGrilledCheeseButton().setVisible(false);

                view.form.getLargeFryButton().setVisible(false);
                view.form.getMediumFryButton().setVisible(false);
                view.form.getSmallFryButton().setVisible(false);

                view.form.getMediumSodaButton().setVisible(true);
                view.form.getSmallSodaButton().setVisible(true);
                view.form.getLargeSodaButton().setVisible(true);
            }
        });

        view.form.getAllButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                view.form.getDoubleBurgerButton().setVisible(true);
                view.form.getBurgerButton().setVisible(true);
                view.form.getHotDogButton().setVisible(true);
                view.form.getGrilledCheeseButton().setVisible(true);

                view.form.getLargeFryButton().setVisible(true);
                view.form.getMediumFryButton().setVisible(true);
                view.form.getSmallFryButton().setVisible(true);

                view.form.getMediumSodaButton().setVisible(true);
                view.form.getSmallSodaButton().setVisible(true);
                view.form.getLargeSodaButton().setVisible(true);
            }
        });

        view.form.getBurgerButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item burger = new Item(0, "Burger", Money.parse(Currency.USD,5.0), ItemCategory.FOOD);
                newAddOnView(burger);
            }
        });
        view.form.getDoubleBurgerButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item doubleBurger = new Item(0, "Double Burger", Money.parse(Currency.USD, 6.0), ItemCategory.FOOD);
                newAddOnView(doubleBurger);
            }
        });
        view.form.getHotDogButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item hotDog = new Item(0, "Hot Dog", Money.parse(Currency.USD,3.0), ItemCategory.FOOD);
                newAddOnView(hotDog);
            }
        });
        view.form.getGrilledCheeseButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item grilledCheese = new Item(0, "Grilled Cheese", Money.parse(Currency.USD, 3.0), ItemCategory.FOOD);
                newAddOnView(grilledCheese);
            }
        });
        view.form.getSmallFryButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item smallFry = new Item(0, "Small Fry", Money.parse(Currency.USD, 2.0), ItemCategory.FOOD);
                newAddOnView(smallFry);
            }
        });
        view.form.getMediumFryButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item medFry = new Item(0, "Medium Fry", Money.parse(Currency.USD, 2.0), ItemCategory.FOOD);
                newAddOnView(medFry);
            }
        });
        view.form.getLargeFryButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item lrgFry = new Item(0, "Large Fry", Money.parse(Currency.USD, 2.0), ItemCategory.FOOD);
                newAddOnView(lrgFry);
            }
        });

        view.form.getSmallSodaButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item i = new Item(0, "Small Soda", Money.parse(Currency.USD, 1.5), ItemCategory.FOOD);
                newAddOnView(i);
            }
        });
        view.form.getMediumSodaButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item i = new Item(0, "Medium Soda", Money.parse(Currency.USD, 2.0), ItemCategory.FOOD);
                newAddOnView(i);
            }
        });
        view.form.getLargeSodaButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                Item i = new Item(0, "Large Soda", Money.parse(Currency.USD, 2.5), ItemCategory.FOOD);
                newAddOnView(i);
            }
        });


        view.form.getTotalButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                pay();
            }
        });
    }

    private void newRefundView() {
        refundViewForm view = new refundViewForm();
        refundController controller = new refundController(view, this.model);
        view.setVisible(true);
    }

    private void pay(){
        if(model.getActiveOrder().getItems().isEmpty()){
            JOptionPane.showMessageDialog(new JFrame(), "This order has no items!", "Error", JOptionPane.ERROR_MESSAGE);
        } else {
            payViewForm view = new payViewForm();
            payController payController = new payController(view, model, this.view);
            view.setVisible(true);
        }
    }

    private void newAddOnView(Item item){
        itemViewForm view = new itemViewForm();
        itemController itemController = new itemController(view, item, model, this);
        view.setVisible(true);
    }

    public void updateOrderDisplay(){
        view.form.getTotalButton().setText(
                "Total: " + model.getActiveOrder().getTotal().toString()
        );
        view.form.getOrderDetail().setText(model.getActiveOrder().toString());
    }
}
