package controller;

import model.Currency;
import model.Register;
import model.Money;
import view.homeViewForm;
import view.orderFinalViewForm;
import view.payViewForm;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class payController {

    private payViewForm view;
    private Register model;
    private homeViewForm homeRef;

    //////// pennsylvania use only (2023) ////////////////////////////////
    private final double localTax = 0.0034;
    private final double stateTax = 0.06;
    private final double tax = stateTax + localTax;

    public payController(payViewForm view, Register model, homeViewForm homeRef){
        this.view = view;
        this.model = model;
        this.homeRef = homeRef;

        view.form.getTotalField().setText(model.getActiveOrder().getTotal().toString());
        view.form.getTaxField().setText(String.format("%.4f", tax));
        view.form.getGrandTotalField().setText(Money.tax(model.getActiveOrder().getTaxable(), tax, Currency.USD).toString());

        view.form.getCancelButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                view.dispose();
            }
        });

        view.form.getUpdateButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String str = view.form.getTaxField().getText();

                try{
                    double newTax = Double.parseDouble(str);
                    view.form.getTaxField().setForeground(Color.BLACK);
                    view.form.getGrandTotalField().setText(Money.tax(model.getActiveOrder().getTaxable(), newTax, Currency.USD).toString());
                } catch (NumberFormatException ee){
                    view.form.getTaxField().setForeground(Color.RED);
                }
            }
        });

        view.form.getTenBill().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {finalView(10);}
        });
        view.form.getTwentyBill().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {finalView(20);}
        });
        view.form.getThirtyBill().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {finalView(30);}
        });
        view.form.getFortyBill().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {finalView(40);}
        });
        view.form.getFiftyBill().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {finalView(50);}
        });
        view.form.getPayButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                try{
                    double amount = Double.parseDouble(view.form.getTextField1().getText());
                    Money grandTotal = new Money(Double.parseDouble(view.form.getGrandTotalField().getText().substring(1)));

                    if(amount >= grandTotal.castToDouble()){
                        view.form.getTextField1().setForeground(Color.BLACK);
                        finalView(amount);
                    } else {
                        view.form.getTextField1().setForeground(Color.RED);
                    }
                } catch (NumberFormatException ee){
                    view.form.getTextField1().setForeground(Color.RED);
                }
            }
        });
        view.form.getSpecialButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                finalViewNOCAHS();
            }
        });
    }

    private Money getChange(double payment){
        Money m = new Money(payment);
        Money grandTotal = new Money(Double.parseDouble(view.form.getGrandTotalField().getText().substring(1)));
        Money change = m.subtract(grandTotal);

        return change;
    }

    private void finalView(double amount){
        if (amount > model.getActiveOrder().getTotal().castToDouble()) {
            view.form.getTextField1().setForeground(Color.BLACK);
            orderFinalViewForm finalOrderForm = new orderFinalViewForm(model.getActiveOrder().getId(), getChange(amount).toString(), homeRef, model);
            finalOrderForm.setVisible(true);
            view.dispose();
        } else {
            JOptionPane.showMessageDialog(new JFrame(), "Grand total exceeds payment!", "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    private void finalViewNOCAHS(){
        view.form.getTextField1().setForeground(Color.BLACK);
        orderFinalViewForm finalOrderForm = new orderFinalViewForm(model.getActiveOrder().getId(), "N/a", homeRef, model);
        finalOrderForm.setVisible(true);
        view.dispose();
    }

}
