package controller;

import model.Currency;
import model.Money;
import model.Order;
import model.Register;
import view.refundViewForm;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class refundController {

    private refundViewForm view;
    private Register modelRef;
    private Order refundOrder;

    //////// pennsylvania use only (2023) ////////////////////////////////
    private final double localTax = 0.0034;
    private final double stateTax = 0.06;
    private final double tax = stateTax + localTax;

    public refundController(refundViewForm view, Register modelRef){
        this.view = view;
        this.modelRef = modelRef;

        view.form.getCancelButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                view.dispose();
            }
        });

        view.form.getLookUpButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                findOrder();
            }
        });

        view.form.getRefundButton().addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if(refundOrder != null){
                    if(refundOrder.isRefunded()){
                        String errorMessage = "Order " + refundOrder.getId() + " has already been refunded.";
                        JOptionPane.showMessageDialog(new JFrame(), errorMessage , "Refund", JOptionPane.ERROR_MESSAGE);
                    } else {
                        Money refundAmount = Money.parse(refundOrder.getTotal().getCurrency(), refundOrder.getTotal().castToDouble() * (1 + tax));
                        view.form.getOrderIDField().setText("");
                        String message = "Order " + refundOrder.getId() + " refunded.";
                        view.form.getOrderDetailPane().setText(message);
                        message = message + " Please issue the customer " + refundAmount + ".";
                        modelRef.refundOrder(refundOrder.getId());
                        refundOrder.setRefund(true);
                        JOptionPane.showMessageDialog(new JFrame(), message, "Refund", JOptionPane.INFORMATION_MESSAGE);
                    }
                }
            }
        });
    }


    public void findOrder(){
        String idStr = view.form.getOrderIDField().getText();
        view.form.getOrderIDField().setForeground(Color.BLACK);

        try{
            int id = Integer.parseInt(idStr);
            try {
                refundOrder = modelRef.getOrderById(id);
                view.form.getOrderDetailPane().setText(refundOrder.toString());
                view.form.getRefundButton().setEnabled(true);
            } catch (RuntimeException eee) {
                view.form.getOrderDetailPane().setText("Order not found.");
                view.form.getRefundButton().setEnabled(false);
                JOptionPane.showMessageDialog(new JFrame(), eee.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
            }

        } catch (NumberFormatException ee){
            view.form.getOrderIDField().setForeground(Color.RED);
        }
    }
}
